package com.chelvc.cloud.admin.vo;

import java.io.Serializable;
import java.util.List;

import com.chelvc.framework.base.model.Tree;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.ToString;
import lombok.experimental.SuperBuilder;

/**
 * 我的信息
 *
 * @author Woody
 * @date 2021/11/1
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class MineVO implements Serializable {
    /**
     * 主键
     */
    private Long id;

    /**
     * 员工姓名
     */
    private String name;

    /**
     * 电子邮箱
     */
    private String email;

    /**
     * 电话号码
     */
    private String mobile;

    /**
     * 角色列表
     */
    private List<RoleVO> roles;

    /**
     * 菜单列表
     */
    private List<MenuVO> menus;

    /**
     * 所属部门
     */
    private DepartmentVO department;

    /**
     * 部门信息
     */
    @Data
    @SuperBuilder
    @NoArgsConstructor
    @AllArgsConstructor
    public static class DepartmentVO implements Serializable {
        /**
         * 组织主键
         */
        private Long id;

        /**
         * 组织名称
         */
        private String name;
    }

    /**
     * 角色信息
     */
    @Data
    @SuperBuilder
    @NoArgsConstructor
    @AllArgsConstructor
    public static class RoleVO implements Serializable {
        /**
         * 主键
         */
        private Long id;

        /**
         * 角色名称
         */
        private String name;
    }

    /**
     * 组织信息
     */
    @Data
    @SuperBuilder
    @NoArgsConstructor
    @AllArgsConstructor
    @ToString(callSuper = true)
    @EqualsAndHashCode(callSuper = true)
    public static class MenuVO extends Tree.Simple<Long, MenuVO> {
        /**
         * 菜单名称
         */
        private String name;

        /**
         * 菜单图标
         */
        private String icon;

        /**
         * 菜单路径
         */
        private String path;
    }
}
